#define maxSize 1000000
#define max2 1000

#include <stdio.h>
#include <algorithm>

using namespace std;

int T, N, M, cols[maxSize], rows[maxSize];
int matrix[max2][max2];

bool rec(int col)
{
    if (col == N)
    {
        for (int i = 0; i < M; i++)
        {
            int sum = 0;
            for (int j = 0; j < N; j++)
                sum += matrix[j][i];
            if (sum != rows[i])
                return false;
        }
        return true;
    }

    do {
        if (rec(col + 1))
            return true;
    } while (next_permutation(matrix[col], matrix[col] + M));

    return false;
}

bool check()
{
    long long colSum = 0, rowSum = 0;
    for (int i = 0; i < N; i++)
        colSum += cols[i];
    for (int i = 0; i < M; i++)
        rowSum += rows[i];
    if (colSum != rowSum)
        return false;

    for (int i = 0; i < N; i++)
    {
        for (int j = 0; j < M - cols[i]; j++)
            matrix[i][j] = 0;
        for (int j = M - cols[i]; j < M; j++)
            matrix[i][j] = 1;
    }
    return rec(0);
}

int main()
{
    freopen("puzzle.dat", "r", stdin);
    freopen("puzzle.sol", "w", stdout);

    scanf("%d", &T);
    for (int test = 0; test < T; test++)
    {
        scanf("%d %d", &N, &M);
        for (int i = 0; i < N; i++)
            scanf("%d", &cols[i]);
        for (int i = 0; i < M; i++)
            scanf("%d", &rows[i]);
        printf("%d\n", check() ? 1 : 0);
    }

    return 0;
}
