#define maxN 100000

#include <stdio.h>
#include <vector>

using namespace std;

vector<pair<int, bool> > edges[maxN];
int left[maxN], right[maxN];
vector<int> order;
bool visited[maxN];

void dfs(int current)
{
    visited[current] = true;
    for (int i = 0; i < edges[current].size(); i++)
    {
        int added = edges[current][i].first;
        if (visited[added])
            continue;
        order.push_back(added);
        if (edges[current][i].second)
        {
            left[added] = current;
            right[added] = right[current];
            if (right[added] != -1)
                left[right[added]] = added;
            right[current] = added;
        } else
        {
            right[added] = current;
            left[added] = left[current];
            if (left[added] != -1)
                right[left[added]] = added;
            left[current] = added;
        }
        dfs(added);
    }
}

int main()
{
    freopen("permutation.dat", "r", stdin);
    freopen("permutation.sol", "w", stdout);

    int N, M;
    scanf("%d %d", &N, &M);

    for (int i = 0; i < M; i++)
    {
        int a, b;
        scanf("%d %d", &a, &b);
        a--;
        b--;
        edges[a].push_back(make_pair(b, true));
        edges[b].push_back(make_pair(a, false));
    }

    for (int i = 0; i < N; i++)
    {
        left[i] = right[i] = -1;
        visited[i] = false;
    }

    dfs(0);

    if (order.size() == N - 1)
    {
        int current = 0;
        while (left[current] != -1)
            current = left[current];
        printf("%d", current + 1);
        while (right[current] != -1)
        {
            current = right[current];
            printf(" %d", current + 1);
        }
        printf("\n");
        for (int i = order.size() - 1; i >= 0; i--)
            printf(i > 0 ? "%d " : "%d\n", order[i] + 1);
    } else
        printf("0\n");

    return 0;
}
