const maxN = 100000;

type edge = record
    first: longint;
    second: boolean;
end;

var
    edges: array[1..maxN] of array of edge;
    left, right: array[1..maxN] of longint;
    order: array of longint;
    f: text;
    N, M, i, a, b, currentIndex, current, added: longint;

begin
    assign(f, 'permutation.dat');
    reset(f);
    read(f, N, M);
    for i := 1 to M do begin
        read(f, a, b);

        setlength(edges[a], length(edges[a]) + 1);
        edges[a][length(edges[a]) - 1].first := b;
        edges[a][length(edges[a]) - 1].second := true;

        setlength(edges[b], length(edges[b]) + 1);
        edges[b][length(edges[b]) - 1].first := a;
        edges[b][length(edges[b]) - 1].second := false;
    end;
    close(f);

    for i := 1 to N do begin
        left[i] := -1;
        right[i] := -1;
    end;

    setlength(order, 1);
    order[0] := 1;
    currentIndex := 0;
    while currentIndex < length(order) do begin
        current := order[currentIndex];
        inc(currentIndex);
        for i := 0 to length(edges[current]) - 1 do begin
            added := edges[current][i].first;
            if (left[added] = -1) and (right[added] = -1) then begin
                setlength(order, length(order) + 1);
                order[length(order) - 1] := added;
                if edges[current][i].second then begin
                    left[added] := current;
                    right[added] := right[current];
                    if right[added] <> -1 then
                        left[right[added]] := added;
                    right[current] := added;
                end else begin
                    right[added] := current;
                    left[added] := left[current];
                    if left[added] <> -1 then
                        right[left[added]] := added;
                    left[current] := added;
                end;
            end;
        end;
    end;

    assign(f, 'permutation.sol');
    rewrite(f);
    if length(order) = N then begin
        current := 1;
        while left[current] <> -1 do
            current := left[current];
        write(f, current);
        while right[current] <> -1 do begin
            current := right[current];
            write(f, ' ', current);
        end;
        writeln(f);
        for i := length(order) - 1 downto 1 do begin
            write(f, order[i]);
            if i > 1 then write(f, ' ') else writeln(f);
        end;
    end else
        writeln(f, '0');
    close(f);
end.
